<?php include_once("../lib/control.seguridad.php"); ?>
<?php
    include_once('../inc/api_cred.php');

	$boton = "<button type='button' class='btn btn-info btn-sm' id='btnEnviar' name='btnEnviar'>INGRESAR</button>";
	
	$id = 0;
	$fecha = date("Y-m-d");
	$hora_inicio = "00:00";
	$hora_termino = "00:30";
	$id_tipo_justificacion = 1;		
	$id_tipo_marcaje = -1;		
	$id_persona = 0;	
	$id_autoriza = $_SESSION['LOGIN']['CODIGO'];
	$observacion = "";	
	$nombrePersona = "";
	$nombreAutoriza = $_SESSION['LOGIN']['NOMBRE'];	
	
    if($_POST){

		$hide = "";
		$url = $apiUrl . '/public/obtenerjustificacion';
		$ch = curl_init($url); //create a new cURL resource
		$payload = json_encode(array('id' => $_POST["txtId"]));
		curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);//attach encoded JSON string to the POST fields
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json')); //set the content type to application/json
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); //return response instead of outputting
		$result = curl_exec($ch); //execute the POST request
        $array = json_decode($result);


		$id = $array[0]->id;
		$fecha = $array[0]->fecha;
		$hora_inicio = $array[0]->hora_inicio;
		$hora_termino = $array[0]->hora_termino;	
		$id_tipo_justificacion = $array[0]->id_tipo_justificacion;		
		$id_tipo_marcaje = $array[0]->id_tipo_marcaje;
		$id_persona = $array[0]->id_persona;	
		$id_autoriza = $array[0]->id_autoriza;
		$observacion = $array[0]->observacion;	

		$url2 = $apiUrl . '/public/obtenerpersona';
		$ch2 = curl_init($url2); //create a new cURL resource
		$payload2 = json_encode(array('id' => $id_persona));
		curl_setopt($ch2, CURLOPT_POSTFIELDS, $payload2);//attach encoded JSON string to the POST fields
		curl_setopt($ch2, CURLOPT_HTTPHEADER, array('Content-Type:application/json')); //set the content type to application/json
		curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true); //return response instead of outputting
		$result2 = curl_exec($ch2); //execute the POST request
		$array2 = json_decode($result2);
	
		$nombrePersona = $array2[0]->nombre ." ". $array2[0]->apellido;
		curl_close($ch2); 

		$url2 = $apiUrl . '/public/obtenerpersona';
		$ch2 = curl_init($url2); //create a new cURL resource
		$payload2 = json_encode(array('id' => $id_autoriza));
		curl_setopt($ch2, CURLOPT_POSTFIELDS, $payload2);//attach encoded JSON string to the POST fields
		curl_setopt($ch2, CURLOPT_HTTPHEADER, array('Content-Type:application/json')); //set the content type to application/json
		curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true); //return response instead of outputting
		$result2 = curl_exec($ch2); //execute the POST request
		$array2 = json_decode($result2);
	
		$nombreAutoriza = $array2[0]->nombre ." ". $array2[0]->apellido;
		curl_close($ch2); 			
		
		curl_close($ch); 


		$boton = "<button type='button' class='btn btn-info btn-sm' id='btnEditar' name='btnEditar'>EDITAR</button>";
	}

?>
<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <title>POWERTIME</title>
  <!-- Tell the browser to be responsive to screen width -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="../plugins/fontawesome-free/css/all.min.css">
  <!-- Ionicons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="../dist/css/adminlte.min.css">
  <!-- DataTables -->
  <link rel="stylesheet" href="../plugins/datatables-bs4/css/dataTables.bootstrap4.css">
  <!-- JQUERY TIMEPICKER -->  
  <link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/timepicker/1.3.5/jquery.timepicker.min.css"> 
  
  <link href="../plugins/toastr/build/toastr.css" rel="stylesheet" type="text/css" />
  <style>
	  label{
		  font-size:11px;
	  }
	  #example3{
		  font-size:10px;
	  }    
       .dataTables_wrapper { font-size: 10px }	  
  </style>  
</head>
<body class="hold-transition sidebar-mini">
<div class="wrapper">
 
  <?php include_once("../inc/header.php"); ?>

  <?php include_once("../inc/menu.php"); ?>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row">
          <div class="col-sm-8">
            <h4>Justificaci&oacute;n</h4>
          </div>
			<div class="col-md-4">
			  <div class="input-group mb-2 input-group-sm">
				<div class="input-group-prepend">
				  <div class="input-group-text">Autoriza</div>
				</div>
				<input type="text" class="form-control control-text" id="txtNombre_autoriza" value="<?php echo $nombreAutoriza ?>" readonly>
				<input type="hidden" class="form-control control-text" id="txtId_autoriza" value="<?php echo $id_autoriza ?>">
			  </div>
			</div>			  
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content" id="app">
      <div class="container-fluid">
        <div class="row">
          <!-- left column -->
          <div class="col-md-6">
            <!-- Horizontal Form -->
            <div class="card">
				<div class="card-body">
				  <div class="form-group input-group-sm">
					<label>Fecha :</label>
					<input type="text" class="form-control" id="txtFecha" value="<?php echo $fecha ?>" readonly>
					<small class="form-text text-muted">Fecha ejecuci&oacute;n Hora Extra.</small>
				  </div>			
				  <div class="form-group input-group-sm">
					<label>Tipo de Justificaci&oacute;n :</label>
					<select class="form-control" id="txtTipo_justificacion">
					</select>
					<small class="form-text text-muted">Tipo de Marcaje a Justificaci&oacute;n de Inasistencia .</small> 
				  </div>					  
				  <div class="form-group input-group-sm d-none" id="div-hora-inicio">
					<label>Hora Inicio:</label>
					<input type="text" class="form-control control-text" id="txtHora_inicio" value="<?php echo $hora_inicio ?>" readonly>
					<small class="form-text text-muted">Hora Inicio Inasistencia.</small>
				  </div>	
				  <div class="form-group input-group-sm d-none" id="div-hora-termino">
					<label>Hora T&eacute;rmino:</label>
					<input type="text" class="form-control control-text" id="txtHora_termino" value="<?php echo $hora_termino ?>" readonly>
					<small class="form-text text-muted">Hora T&eacute;rmino de Inasistencia.</small>
				  </div>	
				  <div class="form-group input-group-sm d-none" id="div-tipo-marcaje">
					<label>Tipo Marcaje :</label>
					<select class="form-control" id="txtTipo_marcaje">
						<option value="-1">Seleccione...</option>
					</select>
					<small class="form-text text-muted">Tipo de Marcaje a Justificar .</small>
				  </div>				  
				</div>
				<!-- /.card-body -->
				<div class="card-footer">
					<?php echo $boton ?>
					<input type="hidden" class="form-control control-text" id="txtId" value="<?php echo $id ?>" readonly>						
					<button type="button" class="btn btn-default float-right" id="btnLimpiar">Limpiar</button>
				</div>
            </div>
          </div>
          <div class="col-md-6">
            <!-- Horizontal Form -->
            <div class="card">
				<div class="card-body">			
				  <div class="form-group">
					<label>Trabajador:</label>
						<div class="row">
							<div class="col-md-9 input-group-sm">
								<input type="text" class="form-control control-text" id="txtNombre" value="<?php echo $nombrePersona ?>" readonly>
								<input type="hidden" class="form-control control-text" id="txtId_persona" value="<?php echo $id_persona ?>">
							</div>
							<div class="col-md-3">
								<button type="button" class="btn btn-info float-right btn-sm btn-block" id="btnBuscar">Buscar</button>
							</div>
						</div>
					<small class="form-text text-muted">Trabajador que se asignara la Justificaci&oacute;n.</small>
				  </div>			  
				  <div class="form-group">
					<label>Observaci&oacute;n:</label>
					<textarea class="form-control control-text" id="txtObservacion" rows="5"><?php echo $observacion ?></textarea>
					<small class="form-text text-muted">Observaci&oacute;nes de asignaci&oacute;n de Justificaci&oacute;n.</small>
				  </div>				  
			  
				</div>
				<!-- /.card-body -->
				<div class="card-footer">					
					
				</div>
            </div>
          </div>
        </div>
        <!-- /.row -->
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  
  <?php include_once("../inc/footer.php"); ?>
  
	<div class="modal fade bd-example-modal-xl" id="modal-buscar" tabindex="-1" role="dialog" aria-labelledby="myExtraLargeModalLabel" aria-hidden="true">
	  <div class="modal-dialog modal-xl">
		<div class="modal-content">
		  <div class="modal-header">
			<h5 class="modal-title">LISTADO DE TRABAJADORES</h5>
			<button type="button" class="close" data-dismiss="modal" aria-label="Close">
			  <span aria-hidden="true">&times;</span>
			</button>
		  </div>
		  <div class="modal-body">
			 <div class="row">
				<div class="col-md-4">
				  <div class="form-group  input-group-sm">
					<input type="text" class="form-control control-text" id="txtCriterio">
					<small class="form-text text-muted">Ingrese criterio de b&uacute;sqeda (Rut / Nombre / Apellido).</small>
				  </div>				
				</div>
				<div class="col-md-4">
				  <div class="form-group">
                     <button type='button' class='btn btn-info btn-sm' id='btnFiltro' name='btnFiltro'>APLICAR FILTRO</button>
				  </div>				
				</div>				
			 </div>		  
			 <div class="row">
				<div class="col-md-12">
				  <table id="example3" class="table table-bordered table-striped">
					<thead>
					<tr>	
					  <th>RUT</th>					
					  <th>NOMBRE</th>
					  <th>DEPARTAMENTO</th>					  
					  <th>TURNO</th>				
					  <th>CARGO</th>			  
					  <th></th>				  
					</tr>
					</thead>			
				  </table>					
				</div>
			 </div>
		  </div>
		  <div class="modal-footer">
			<button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
		  </div>
		</div>
	  </div>
	</div>  


	
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="../plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="../plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE App -->
<script src="../dist/js/adminlte.min.js"></script>
<!-- DataTables -->
<script src="../plugins/datatables/jquery.dataTables.js"></script>
<script src="../plugins/datatables-bs4/js/dataTables.bootstrap4.js"></script>
<!-- JQUERY TIMEPICKER -->  
<script src="//cdnjs.cloudflare.com/ajax/libs/timepicker/1.3.5/jquery.timepicker.min.js"></script>

<script src="../plugins/toastr/toastr.js"></script>

<link rel="stylesheet" href="../plugins/jQueryUI/jquery-ui.css" />
<script src="../plugins/jQueryUI/jquery-ui.js"></script>


<script>

  $(function () {
	  
	$("#txtTipo_justificacion").change(function () {
		if(parseInt($("#txtTipo_justificacion").val()) == 1){
			$("#div-hora-inicio").addClass("d-none"); 
			$("#div-hora-termino").addClass("d-none");
			$("#div-tipo-marcaje").addClass("d-none");
			$("#txtHora_inicio").val("00:00");
			$("#txtHora_termino").val("00:00");				
			$("#txtTipo_marcaje").val(-1);				
			
		}else{
			$("#div-hora-inicio").removeClass("d-none"); 
			$("#div-hora-termino").removeClass("d-none");
			$("#div-tipo-marcaje").removeClass("d-none");
		}
    });	  
	  
    $(document).bind("contextmenu",function(e){
      return false;
    });	  

    $('#txtObservacion').keyup(function(){
        $(this).val($(this).val().toUpperCase());
    });		
	  
	$('#txtHora_inicio').timepicker({ 
		timeFormat: 'HH:mm',
		interval: 30,
		minTime: '00:00',
		maxTime: '23:30',
		dynamic: false,
		dropdown: true,
		scrollbar: true		
	});	
	$('#txtHora_termino').timepicker({ 
		timeFormat: 'HH:mm',
		interval: 30,
		minTime: '00:00',
		maxTime: '23:30',
		dynamic: false,
		dropdown: true,
		scrollbar: true		
	});		
	
	combo();
	function combo(){
		$.ajax({
			type:'POST',
			contentType: 'application/json',
			dataType: "json",
            crossDomain: true,
			headers: {
				'Content-Type': 'application/json'
			},
			url: "<?php include_once('../inc/api_cred.php'); echo $apiUrl; ?>/public/tipomarcaje",		
			success: function(dados)
			{
				for (i=0;i<dados.length;i++){
					for (j=0;j<dados[i].length;j++){
						$('#txtTipo_marcaje').append($('<option>', {
							value: dados[i][j].id,
							text : dados[i][j].descripcion
						}));
					}
				}
				$('#txtTipo_marcaje').val(<?php echo $id_tipo_marcaje ?>);
			}
		});	
		$.ajax({
			type:'POST',
			contentType: 'application/json',
			dataType: "json",
            crossDomain: true,
			headers: {
				'Content-Type': 'application/json'
			},
			url: "<?php include_once('../inc/api_cred.php'); echo $apiUrl; ?>/public/tipojustificacion",		
			success: function(dados)
			{
				for (i=0;i<dados.length;i++){
					for (j=0;j<dados[i].length;j++){
						$('#txtTipo_justificacion').append($('<option>', {
							value: dados[i][j].id,
							text : dados[i][j].descripcion
						}));
					}
				}
				$('#txtTipo_marcaje').val(<?php echo $id_tipo_justificacion ?>);
			}
		});			
	}
	
	  
	 $.datepicker.regional['es'] = {
	 closeText: 'Cerrar',
	 prevText: '< Ant',
	 nextText: 'Sig >',
	 currentText: 'Hoy',
	 monthNames: ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
	 monthNamesShort: ['Ene','Feb','Mar','Abr', 'May','Jun','Jul','Ago','Sep', 'Oct','Nov','Dic'],
	 dayNames: ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'],
	 dayNamesShort: ['Dom','Lun','Mar','Mié','Juv','Vie','Sáb'],
	 dayNamesMin: ['Do','Lu','Ma','Mi','Ju','Vi','Sá'],
	 weekHeader: 'Sm',
	 dateFormat: 'yy/mm/dd',
	 firstDay: 1,
	 isRTL: false,
	 showMonthAfterYear: false,
	 yearSuffix: ''
	 };
	 $.datepicker.setDefaults($.datepicker.regional['es']);
	 $("#txtFecha").datepicker({
		dateFormat: "yy-mm-dd",
		changeMonth: true,
		changeYear: true,
		yearRange: "1900:2100",
		maxDate: 0 
	 });	
	  

    $('#example3').DataTable({
      "paging": true,
      "lengthChange": false,
      "searching": false,
      "ordering": true,
      "info": true,
      "autoWidth": false,
	  "language": {
		"url": "//cdn.datatables.net/plug-ins/1.10.15/i18n/Spanish.json"
      } 		  
    });	 	  
	  
	$('#txtCriterio').keyup(function(e){
		if(e.keyCode == 13){
			buscarPersona();
		}
	});	  
	  	  
	$("#btnFiltro").click(function(){
	     buscarPersona();
	});
	
	function buscarPersona(){
		$('#example3').dataTable().fnClearTable();
		$.ajax({
			type:'POST',
			contentType: 'application/json',
			dataType: "json",
            crossDomain: true,
			headers: {
				'Content-Type': 'application/json'
			},
			url: "<?php include_once('../inc/api_cred.php'); echo $apiUrl; ?>/public/buscarpersona",
			data : JSON.stringify({
				descripcion: $("#txtCriterio").val()			
			}),			
			success: function(dados)
			{
				$('#example3').dataTable().fnClearTable();
				 for (i=0;i<dados.length;i++){
					for (j=0;j<dados[i].length;j++){
					  var boton = "<button type='button' class='btn btn-info btn-xs btn-editar'>Asignar</button>";
					  $('#example3').dataTable().fnAddData( [
						dados[i][j].rut,						  
						dados[i][j].nombre +" "+dados[i][j].apellido,	
						dados[i][j].departamento,
						dados[i][j].turno,
						dados[i][j].cargo,						
						boton +"<input type='hidden' value ='"+dados[i][j].id+"' />"
					  ]);
					}
				}
			}
		});			
	}

	$("#example3").on('click','.btn-editar', function() {
		var id = $(this).parents("tr").find("td:eq(5)").find("input").val();	
		$.ajax({
			type:'POST',
			contentType: 'application/json',
			dataType: "json",
            crossDomain: true,
			headers: {
				'Content-Type': 'application/json'
			},
			url: "<?php include_once('../inc/api_cred.php'); echo $apiUrl; ?>/public/obtenerpersona",
			data : JSON.stringify({
				id: id			
			}),			
			success: function(dados)
			{
				 for (i=0;i<dados.length;i++){					
					$("#txtNombre").val(dados[i].nombre+" "+dados[i].apellido); 
					$("#txtId_persona").val(id);
					$("#modal-buscar").modal("toggle");											
				}
			}
		});			
	});		
	
	$(".control-number").bind('keypress', function(event) {
	  var regex = new RegExp("^[0-9]+$");
	  var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
	  if (!regex.test(key)) {
		event.preventDefault();
		return false;
	  }
	});	 
	
	$(".control-text").bind('keypress', function(event) {
	  var regex = new RegExp("^[a-zA-Z 0-9 .,-]+$");
	  var key = String.fromCharCode(!event.charCode ? event.which : event.charCode);
	  if (!regex.test(key)) {
		event.preventDefault();
		return false;
	  }
	});	  
	  
	$("#btnEnviar").click(function(){
		if(parseInt($("#txtId_persona").val()) == 0){
			toastr.warning("Debe Seleccionar Persona", "POWERTIME");
			return false;
		}
		else if( $("#txtObservacion").val() == null || $("#txtObservacion").val().length == 0 || /^\s+$/.test($("#txtObservacion").val()) ){
			toastr.warning("Debe ingresar Observaci&oacute;n Justificaci&oacute;n de Marcaje", "POWERTIME");
            return false;
		}		
        else{
			$.ajax({
				type:'POST',
				contentType: 'application/json',
				dataType: "json",
				crossDomain: true,
				headers: {
					'Content-Type': 'application/json'
				},
				url: "<?php include_once('../inc/api_cred.php'); echo $apiUrl; ?>/public/ingresarjustificacion",
				data : JSON.stringify({
					id:$("#txtId").val(),
					fecha:$("#txtFecha").val(),
					hora_inicio:$("#txtHora_inicio").val(),
					hora_termino:$("#txtHora_termino").val(),		
					id_tipo_justificacion:$("#txtTipo_justificacion").val(),						
					id_tipo_marcaje:$("#txtTipo_marcaje").val(),		
					id_persona:$("#txtId_persona").val(),	
					id_autoriza:$("#txtId_autoriza").val(),	
					observacion:$("#txtObservacion").val()				
				}),
				beforeSend : function()
				{
					//$("#mensajeUsuario").html("<div class='alert alert-info'>Enviando datos</div>");
				},
				success: function(data) {
					if(parseInt(data[0]) > 0){
						toastr.success("Registro Ingresado Exitosamente", "POWERTIME");
					} else {
					    toastr.warning("Ha habido un error", "POWERTIME");
					}
				}
			})			
		}
		
	});

	$("#btnEditar").click(function(){
		if(parseInt($("#txtId_persona").val()) == 0){
			toastr.warning("Debe Seleccionar Persona", "POWERTIME");
			return false;
		}
		else if( $("#txtObservacion").val() == null || $("#txtObservacion").val().length == 0 || /^\s+$/.test($("#txtObservacion").val()) ){
			toastr.warning("Debe ingresar Observaci&oacute;n Justificaci&oacute;n de Marcaje", "POWERTIME");
            return false;
		}		
        else{
			$.ajax({
				type:'POST',
				contentType: 'application/json',
				dataType: "json",
				crossDomain: true,
				headers: {
					'Content-Type': 'application/json'
				},
				url: "<?php include_once('../inc/api_cred.php'); echo $apiUrl; ?>/public/actualizarjustificacion",
				data : JSON.stringify({
					id:$("#txtId").val(),
					fecha:$("#txtFecha").val(),
					hora_inicio:$("#txtHora_inicio").val(),
					hora_termino:$("#txtHora_termino").val(),
					id_tipo_justificacion:$("#txtTipo_justificacion").val(),						
					id_tipo_marcaje:$("#txtTipo_marcaje").val(),		
					id_persona:$("#txtId_persona").val(),	
					id_autoriza:$("#txtId_autoriza").val(),	
					observacion:$("#txtObservacion").val()					
				}),
				beforeSend : function()
				{
					//$("#mensajeUsuario").html("<div class='alert alert-info'>Enviando datos</div>");
				},
				success: function(data) {
					if(parseInt(data[0]) > 0){
						toastr.success("Registro Editado Exitosamente", "POWERTIME");
					} else {
					    toastr.warning("Ha habido un error", "POWERTIME");
					}
				}
			})		
		}
		
	});	

	$("#btnBuscar").click(function(){
		$("#modal-buscar").modal("show");		
	});

 	$("#btnLimpiar").click(function(){
		limpiarFormulario();
	});
	
	function limpiarFormulario(){
		$("#txtId").val(0);
		$("#txtFecha").val(fechaActual());
		$("#txtHora_inicio").val("00:00");
		$("#txtHora_termino").val("00:00");				
		$("#txtTipo_marcaje").val(-1);	
		$("#txtTipo_justificacion").val(1);			
		$("#txtId_persona").val(0);	
		$("#txtObservacion").val("");	
		$("#div-hora-inicio").addClass("d-none"); 
		$("#div-hora-termino").addClass("d-none");
		$("#div-tipo-marcaje").addClass("d-none");		
	}
	
	function fechaActual(){
		var fecha = new Date();
		var dia = fecha.getDate();
		var mes = fecha.getMonth();
		var anio = fecha.getFullYear();		
		if(dia < 10) { dia = "0"+dia; } 
		if(mes < 10) { mes = "0"+mes; }
        return anio+"-"+mes+"-"+dia;  		
	}	
	
});	 	
  
</script>

</body>
</html>
